// counttable.h
// the spreadsheet for filling in numbers of coins
// v0.84 (7.3.2002)
// (c) 2002 Andreas Krueger
//
// Please, if you change anything in this code,
// mark the end of those lines with '// *+* your name *+* ' 
// (so that I can find it) and send the code 
// to cye-code@AndreasKrueger.de
//
// last change: 
//          by:

#ifndef COUNTTABLE_H
#define COUNTTABLE_H

#include "classes.h"

#include <qvbox.h> 
#include <qtable.h> 
#include <qlabel.h> 
#include <qpushbutton.h>

#include "constants.h"
#include "helpers.h"

class CountTable : public QVBox{
	Q_OBJECT
public:
	CountTable(uint numRows, uint numCols, QWidget *parent=0, const char *name=0);
	bool value(uint row, uint column, Q_UINT32 &result);
	bool setValue(uint row, uint column, Q_UINT32 result);
	void zeroCell(uint row, uint column);
	double sum;
	vector<vector<Q_UINT32> > toVectorArray();
	void setFromVectorArray(vector<vector<Q_UINT32> > array);

//	QSizePolicy sizePolicy() const;
private:
	QTable *ct;
	QLabel *labelPurseSum;
	AutoErasedCells *theZeroCells;
	bool coordinatesOK(uint row, uint column);
	QString cellCoordName(uint row, uint col);
	int RowHeight;
	int ColWidth;

signals:
	void theSum(double);
	void sumChanged();
	void pleaseChangeToCoinOfCell(uint row, uint column);
	void Event(QString name);

public slots:
	void test();
	void test1();
	void test2();
	void cellEdited(int row, int column);
	void cellClicked ( int row, int col, int button, const QPoint & mousePos ) ;
	void increaseCell(uint row, uint column);
	void decreaseCell(uint row, uint column);
	void setFocusToCell(uint row, uint column);
	void sumUpAndDisplay();
	void reset();
private slots:
	void buttonResetPressed();
	void resetSizeChangeRows( int section, int oldSize, int newSize );
	void resetSizeChangeCols( int section, int oldSize, int newSize );

protected slots:
	void setEmpty(cellCoord theCell);

};


#endif // COUNTTABLE_H
