// cyewindow.h
// The main window
// v0.84 (7.3.2002)
// (c) 2002 Andreas Krueger
//
// Please, if you change anything in this code,
// mark the end of those lines with '// *+* your name *+* ' 
// (so that I can find it) and send the code 
// to cye-code@AndreasKrueger.de
//
// last change: 
//          by:

#ifndef CYEWINDOW_H
#define CYEWINDOW_H

#include "classes.h"

#include <qmainwindow.h>
#include <qvbuttongroup.h>
#include "slideshow.h"
#include "counttable.h"
#include "storage.h"
#include "usage.h"
#include "dialogs.h"
#include "client.h"


class CYEWindow : public QMainWindow
{
	Q_OBJECT
public:
	CYEWindow( QWidget* parent = 0, const char* name = 0, WFlags f = WType_TopLevel );
	void initializeEverything();  // very important! Always do this...
	void storePurseAndWindowPosAndUsageInto(ClientStorage *theData, CountTable *ct, Usage *Observer);
	void closeEvent ( QCloseEvent * e );

private:
	SlideShow		*ss;
	CountTable		*ct;
	ClientStorage	*theData;
	Usage			*Observer; 
	QVButtonGroup	*readyGroupBox;
	QLabel			*labelStoredPurses;
	Dialogs			*theDialogs;
	int				quitreason;
	QTimer			*quitTimer;
	Invitations		*theInvitations;

public slots:
	void increaseCurrent();
	void decreaseCurrent();
	void changeToCoinOfCell(uint row, uint column);
	void changeFocus(uint row, uint column);
	// private ?
	void readyPressed(int button);
	void EventOccurred(QString eventname);
	void buttonInsertPressed();
	void buttonTakeAwayPressed();

private slots:
	void ProcessQuitEvent(int reason);
	void Quit();
	void quitquit();

signals:
	void Event(QString);
	void QuitEvent(int);
};


#endif // CYEWINDOW_H